#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

/***********************************************************************/
#include "ate.h"
#include "ate_spells.h"
#include "add-3ed_extraa.h"
#include "add-3ed_external.h"

#include "FL/fl_file_chooser.h"
#include "FL/Fl_Button.h"
#include "FL/Fl_Browser.h"
#include "FL/Fl_Choice.h"
#include "FL/Fl_Counter.h"

/***********************************************************************/
int i,j,k,l, edited_player=0, log_player=-1;
char sess_lf[55] = {0};
char spell_color[10] = {7,6,3,2,5,49,7,49,6,5};

/***********************************************************************/
char * getTime();
char * getDate();
int do_ate_load_file(int);
int do_ate_cancel_edit();

clericspelldetail *clericSpells = NULL;
wizardspelldetail *wizardSpells = NULL;

char spellType = 0;

/***********************************************************************/
extern int debug;
extern char mybuf[255], mybuf1[255];
extern char mybuf20[25], mybuf21[25];
extern char *myptr;

extern Fl_Choice *ate_edit_skl_dsc[];
extern Fl_Input *ate_edit_skl_val[];

extern Fl_Input *ate_edit_spl_lvl[];
extern Fl_Input *ate_edit_spl_dsc[];
extern Fl_Input *ate_edit_spl_got[];
extern Fl_Input *ate_edit_spl_used[];
extern Fl_Input *ate_system_load_party;
extern Fl_Input *ate_system_load_monst;
extern Fl_Input *ate_system_load_extras;

extern Fl_Input *ate_edit_wp_name[3];
extern Fl_Input *ate_edit_wp_bonus[3];
extern Fl_Input *ate_edit_wp_damage[3];
extern Fl_Input *ate_edit_wp_critical[3];
extern Fl_Input *ate_edit_wp_range[3];

extern Fl_Browser *ate_x_spell_desc;
extern Fl_Browser *ate_x_spell_selector;
extern Fl_Input *ate_x_spell_name;
extern Fl_Choice *ate_x_spell_domain;

extern Fl_Counter *ate_system_sp_lvl;

/***********************************************************************/
void reloadAllNames() {
	if (log_player != -1) {
		ate_session_load->value(log_player);
	} else {
		ate_session_load->clear();
	}
	ate_edit_player->clear();
	ate_edit_monst->clear();

//	ate_session_load->add("", 0, 0, (void *)0);

	for (i=0; i<10; i++) {
		ate_edit_player->add(ATEplayers[i].name, 0, 0, (void *)0);
		ate_session_load->add(ATEplayers[i].name, 0, 0, (void *)0);
	}
	for (i=10; i<20; i++) {
		ate_edit_monst->add(ATEplayers[i].name, 0, 0, (void *)0);
	}
}

/***********************************************************************/
int do_ate_new_session() {
	sprintf(mybuf, "New Session @ %s %s", getDate(), getTime());
if (debug == 1) { printf("DANS:%s\n", mybuf); }
	ate_session_text->add(mybuf);
	ate_session_text->middleline(ate_session_text->size());
}

/***********************************************************************/
int do_ate_new_day() {
if (debug == 1) { printf("DAND:\n"); }
	ate_session_text->add("New Day");
	ate_session_text->middleline(ate_session_text->size());
	for (j=0; j<60; j++) {
		ATEplayers[log_player].my_spells[j].spell_cast = 0;
	}
}

/***********************************************************************/
int do_ate_session_accept() {
if (debug == 1) { printf("DASA:\n"); }
	if (strlen(ate_session_input->value()) > 0) {
		ate_session_text->add(ate_session_input->value());
	}
	if (ate_session_damage->value() != 0) {
		ATEplayers[log_player].hits_cur -= (int )ate_session_damage->value();
		sprintf(mybuf, "Dam: %.0f (Cur: %d)", ate_session_damage->value(), ATEplayers[log_player].hits_cur);
		ate_session_text->add(mybuf);
	}
	ate_session_input->value("");
	ate_session_damage->value(0);
	ate_session_text->middleline(ate_session_text->size());
}

/***********************************************************************/
int do_ate_session_load() {
	sprintf(sess_lf, "%s.log", ate_session_load->text());
	log_player = ate_session_load->value();
//	strcpy(sess_lf, fl_file_chooser("Select a Session Log File", "*.log", NULL));
	if (sess_lf[0] != '.') {
		ate_session_text->load(sess_lf);
//		ate_session_ns->activate();
//		ate_session_nday->activate();
//		ate_session_accept->activate();
		ate_session_save->activate();
		ate_session_action->activate();
	}
	ate_session_text->middleline(ate_session_text->size());
}

/***********************************************************************/
int do_ate_session_save() {
FILE *ofile=NULL;

if (debug == 1) { printf("DASS: %s\n", sess_lf); }
	if ((ofile = fopen(sess_lf, "w+")) != NULL) {
		k = ate_session_text->size();
		for (i=1; i<=k; i++) {
			fprintf(ofile, "%s\n", ate_session_text->text(i));
if (debug == 1) { printf("DASS: %s\n", ate_session_text->text(i)); }
		}
	}
	fclose(ofile);
}

/********************************************************************************/
time_t t;
struct tm *tp;
/********************************************************************************/
void setTimeOnTitle() {
   if (time(&t) != -1) {
      tp = localtime(&t);
      sprintf(mybuf, "AD&D 3rd System (%2.2d:%2.2d)", tp->tm_hour, tp->tm_min);
if (debug == 1) printf("sTOT: %s\n", mybuf);
		if (ATEWindow != NULL) {
    	  	ATEWindow->label(mybuf);
		}
   }
}

/********************************************************************************/
char *getTime() {
char mybuf1[11];

   if (time(&t) != -1) {
      tp = localtime(&t);
      sprintf(mybuf20, "%2.2d:%2.2d", tp->tm_hour, tp->tm_min);
	}
	return(mybuf20);
}

/********************************************************************************/
char *getDate() {

   if (time(&t) != -1) {
      tp = localtime(&t);
      sprintf(mybuf21, "%2.2d/%2.2d/%4.4d", tp->tm_mday, tp->tm_mon+1, tp->tm_year+1900);
	}
	return(mybuf21);
}

/********************************************************************************/
void initialiseATE(char **argv) {
if (debug == 1) printf("iA: \n");
//	ate_session_load->add("", 0, 0, (void *)0);

	ate_edit_tab->value(ate_edit_char_tab);

	ate_edit_accept->deactivate();
	ate_edit_cancel->deactivate();

//	ate_session_ns->deactivate();
//	ate_session_nday->deactivate();
//	ate_session_accept->deactivate();
	ate_session_save->deactivate();
	ate_session_action->deactivate();

	for (i=0; i<20; i++) {
		ate_edit_skl_dsc[i]->menu(SkillSelector);
		ate_edit_skl_val[i]->value("0");
	}
//	memset(ATEplayers[0].name, '\0', sizeof(character) * 20);
	for (i=0; i<10; i++) {
		sprintf(ATEplayers[i].name, "Player-%d", i);
//		for (j=0; j<20; j++) {
//			ATEplayers[i].my_skills[j].skill_id = 255;
//		}
	}
	for (i=10; i<20; i++) {
		sprintf(ATEplayers[i].name, "Monst-%d", i);
	}

	strcpy(ATEsystem.fn_players, "test.pty");
	strcpy(ATEsystem.fn_monsters, "test.mon");
	strcpy(ATEsystem.fn_extras, "test.xta");

	ate_system_load_party->value(ATEsystem.fn_players);
	ate_system_load_monst->value(ATEsystem.fn_monsters);
	ate_system_load_extras->value(ATEsystem.fn_extras);

	do_ate_load_file(0);

//	memset(ATEplayers[1].name, '\0', sizeof(character) * 19);
//	for (i=1; i<10; i++) {
//		sprintf(ATEplayers[i].name, "Player-%d", i);
//	}
	ate_edit_spl_lvl1->color(spell_color[1]);
	ate_edit_spl_lvl2->color(spell_color[2]);
	ate_edit_spl_lvl3->color(spell_color[3]);
	ate_edit_spl_lvl4->color(spell_color[4]);
	ate_edit_spl_lvl5->color(spell_color[5]);
	ate_edit_spl_lvl6->color(spell_color[6]);

	reloadAllNames();

	if (ATEWindow != NULL) {
      	ATEWindow->label(mybuf);
	}
}

/********************************************************************************/
void save_datafile(char *fname, char *data, int len) {
	if ((i = open(fname, O_CREAT|O_TRUNC|O_RDWR, 000)) != -1) {
		write(i, data, len);
		close(i);
	}
}

/********************************************************************************/
void load_datafile(char *fname, char *data, int len) {
	if ((i = open(fname, O_RDONLY, 000)) != -1) {
		read(i, data, len);
		close(i);
	}
}

/********************************************************************************/
int do_ate_load_file(int type) {
	switch(type) {
		case 0: do_ate_load_file(1); do_ate_load_file(2); do_ate_load_file(3);
				break;
		case 1:	load_datafile(ATEsystem.fn_players, ATEplayers[0].name, sizeof(character)*10);
				break;
		case 2:	load_datafile(ATEsystem.fn_monsters, ATEplayers[10].name, sizeof(character)*10);
				break;
		case 3:	load_datafile(ATEsystem.fn_extras, ATEsystem.fn_players, sizeof(ATEsystem));
				break;
	}
}

/********************************************************************************/
int do_ate_save_file(int type) {
	switch(type) {
		case 0: do_ate_save_file(1); do_ate_save_file(2); do_ate_save_file(3);
				break;
		case 1:	save_datafile(ATEsystem.fn_players, ATEplayers[0].name, sizeof(character)*10);
				break;
		case 2:	save_datafile(ATEsystem.fn_monsters, ATEplayers[10].name, sizeof(character)*10);
				break;
		case 3:	save_datafile(ATEsystem.fn_extras, ATEsystem.fn_players, sizeof(ATEsystem));
				break;
	}
}

/********************************************************************************/
int do_ate_edit(int plyr) {

	ate_edit_tab->value(ate_edit_char_tab);

	edited_player = plyr;
if (debug == 1) { printf("dAE: %d\n", plyr); }

	ate_edit_name->value(ATEplayers[edited_player].name);
	sprintf(mybuf, "%d", ATEplayers[edited_player].level); ate_edit_level->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].hits_max); ate_edit_hits_max->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].hits_cur); ate_edit_hits_cur->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].ac); ate_edit_ac->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].saves[0]); ate_edit_save_ref->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].saves[1]); ate_edit_save_fort->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].saves[2]); ate_edit_save_will->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].saves[3]); ate_edit_save_init->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].xp); ate_edit_xp->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].pp); ate_edit_pp->value(mybuf);
	sprintf(mybuf, "%d", ATEplayers[edited_player].gp); ate_edit_gp->value(mybuf);

	for (i=0; i<20; i++) {
		ate_edit_skl_dsc[i]->value(ATEplayers[edited_player].my_skills[i].skill_id);
		sprintf(mybuf, "%d", ATEplayers[edited_player].my_skills[i].skill_value); ate_edit_skl_val[i]->value(mybuf);
	}
	for (i=0; i<60; i++) {
		sprintf(mybuf, "%d", ATEplayers[edited_player].my_spells[i].spell_level); ate_edit_spl_lvl[i]->value(mybuf);
		ate_edit_spl_lvl[i]->color(spell_color[ATEplayers[edited_player].my_spells[i].spell_level]);
		ate_edit_spl_dsc[i]->color(spell_color[ATEplayers[edited_player].my_spells[i].spell_level]);
		ate_edit_spl_dsc[i]->value(ATEplayers[edited_player].my_spells[i].spell_name);
		sprintf(mybuf, "%d", ATEplayers[edited_player].my_spells[i].spell_count); ate_edit_spl_got[i]->value(mybuf);
		sprintf(mybuf, "%d", ATEplayers[edited_player].my_spells[i].spell_cast); ate_edit_spl_used[i]->value(mybuf);
	}
	for (i=0; i<3; i++) {
		ate_edit_wp_name[i]->value(ATEplayers[edited_player].my_weapons[i].weap_name);
		sprintf(mybuf, "%d", ATEplayers[edited_player].my_weapons[i].weap_bonus); ate_edit_wp_bonus[i]->value(mybuf);
		ate_edit_wp_damage[i]->value(ATEplayers[edited_player].my_weapons[i].weap_damage);
		ate_edit_wp_critical[i]->value(ATEplayers[edited_player].my_weapons[i].weap_critical);
		sprintf(mybuf, "%d", ATEplayers[edited_player].my_weapons[i].weap_range); ate_edit_wp_range[i]->value(mybuf);
	}
	ate_edit_notes->value(ATEplayers[edited_player].notes);
	ate_edit_spl_lvl1->value(&ATEplayers[edited_player].spells[1][0]);
	ate_edit_spl_lvl2->value(&ATEplayers[edited_player].spells[2][0]);
	ate_edit_spl_lvl3->value(&ATEplayers[edited_player].spells[3][0]);
	ate_edit_spl_lvl4->value(&ATEplayers[edited_player].spells[4][0]);
	ate_edit_spl_lvl5->value(&ATEplayers[edited_player].spells[5][0]);
	ate_edit_spl_lvl6->value(&ATEplayers[edited_player].spells[6][0]);

	ate_edit_player->deactivate();
	ate_edit_monst->deactivate();
	ate_edit_accept->activate();
	ate_edit_cancel->activate();
}

/********************************************************************************/
int do_ate_accept_edit() {
	strncpy(ATEplayers[edited_player].name, ate_edit_name->value(),18);
	ATEplayers[edited_player].name[19] = '\0';
	ATEplayers[edited_player].level = atoi(ate_edit_level->value());
	ATEplayers[edited_player].hits_max = atoi(ate_edit_hits_max->value());
	ATEplayers[edited_player].hits_cur = atoi(ate_edit_hits_cur->value());
	ATEplayers[edited_player].ac = atoi(ate_edit_ac->value());
	ATEplayers[edited_player].saves[0] = atoi(ate_edit_save_ref->value());
	ATEplayers[edited_player].saves[1] = atoi(ate_edit_save_fort->value());
	ATEplayers[edited_player].saves[2] = atoi(ate_edit_save_will->value());
	ATEplayers[edited_player].saves[3] = atoi(ate_edit_save_init->value());
	ATEplayers[edited_player].xp = atoi(ate_edit_xp->value());
	ATEplayers[edited_player].pp = atoi(ate_edit_pp->value());
	ATEplayers[edited_player].gp = atoi(ate_edit_gp->value());

	for (i=0; i<20; i++) {
		ATEplayers[edited_player].my_skills[i].skill_id = ate_edit_skl_dsc[i]->value();
		ATEplayers[edited_player].my_skills[i].skill_value = atoi(ate_edit_skl_val[i]->value());
	}
	for (i=0; i<60; i++) {
		ATEplayers[edited_player].my_spells[i].spell_level = atoi(ate_edit_spl_lvl[i]->value());
		strncpy(ATEplayers[edited_player].my_spells[i].spell_name, ate_edit_spl_dsc[i]->value(), 29);
		ATEplayers[edited_player].my_spells[i].spell_name[29] = '\0';
		ATEplayers[edited_player].my_spells[i].spell_count = atoi(ate_edit_spl_got[i]->value());
		ATEplayers[edited_player].my_spells[i].spell_cast = atoi(ate_edit_spl_used[i]->value());
	}
	for (i=0; i<3; i++) {
		strcpy(ATEplayers[edited_player].my_weapons[i].weap_name, ate_edit_wp_name[i]->value());
		ATEplayers[edited_player].my_weapons[i].weap_bonus = atoi(ate_edit_wp_bonus[i]->value());
		strcpy(ATEplayers[edited_player].my_weapons[i].weap_damage, ate_edit_wp_damage[i]->value());
		strcpy(ATEplayers[edited_player].my_weapons[i].weap_critical, ate_edit_wp_critical[i]->value());
		ATEplayers[edited_player].my_weapons[i].weap_range = atoi(ate_edit_wp_range[i]->value());
	}
	strncpy(ATEplayers[edited_player].notes, ate_edit_notes->value(), 109);
	strcpy(&ATEplayers[edited_player].spells[1][0], ate_edit_spl_lvl1->value());
	strcpy(&ATEplayers[edited_player].spells[2][0], ate_edit_spl_lvl2->value());
	strcpy(&ATEplayers[edited_player].spells[3][0], ate_edit_spl_lvl3->value());
	strcpy(&ATEplayers[edited_player].spells[4][0], ate_edit_spl_lvl4->value());
	strcpy(&ATEplayers[edited_player].spells[5][0], ate_edit_spl_lvl5->value());
	strcpy(&ATEplayers[edited_player].spells[6][0], ate_edit_spl_lvl6->value());

	do_ate_cancel_edit();
	reloadAllNames();
}

/********************************************************************************/
int do_ate_cancel_edit() {
	ate_edit_name->value("");
	ate_edit_level->value("");
	ate_edit_hits_max->value("");
	ate_edit_hits_cur->value("");
	ate_edit_ac->value("");
	for (i=0; i<20; i++) {
		ate_edit_skl_dsc[i]->value(0);
		ate_edit_skl_val[i]->value("");
	}
	for (i=0; i<60; i++) {
		ate_edit_spl_lvl[i]->value("");
		ate_edit_spl_dsc[i]->value("");
		ate_edit_spl_got[i]->value("");
		ate_edit_spl_used[i]->value("");
		ate_edit_spl_dsc[i]->color(7);
	}
	ate_edit_player->activate();
	ate_edit_monst->activate();
	ate_edit_accept->deactivate();
	ate_edit_cancel->deactivate();
}

/********************************************************************************/
int getWindowEvent(int e) {
	return e;
}

/********************************************************************************/
int do_ate_spell_sort() {
	taken_spell ms[60];
	UCHAR st[60];

	for (i=0; i<60; i++) {
		ms[i].spell_level = atoi(ate_edit_spl_lvl[i]->value());
		strncpy(ms[i].spell_name, ate_edit_spl_dsc[i]->value(), 29);
		ms[i].spell_name[29] = '\0';
		ms[i].spell_count = atoi(ate_edit_spl_got[i]->value());
		ms[i].spell_cast = atoi(ate_edit_spl_used[i]->value());
		st[i] = 255;
if (debug == 1 && ms[i].spell_name[0] != '\0') printf("dASS: %d = %d %s\n", i, ms[i].spell_level, ms[i].spell_name);
	}
	k=0;
	for (i=0; i<10; i++) {
		for (j=0; j<60; j++) {
			if (ms[j].spell_level == i && ms[j].spell_name[0] != '\0') {
if (debug == 1) printf("dASS: %d (%d) = %d (%s)\n", j, ms[j].spell_level, k, ms[j].spell_name);
				st[k++] = j;
				ms[j].spell_level *= -1;
			}
		}
	}
	for (i=0; i<60; i++) {
		ate_edit_spl_lvl[i]->value("");
		ate_edit_spl_dsc[i]->value("");
		ate_edit_spl_got[i]->value("");
		ate_edit_spl_used[i]->value("");
	}
	for (i=0; i<60; i++) {
		k = st[i];
		if (k != 255) {
			ms[k].spell_level *= -1;
if (debug == 1) printf("dASS: %d = %d\n", i, k);
			sprintf(mybuf, "%d", ms[k].spell_level); ate_edit_spl_lvl[i]->value(mybuf);
			ate_edit_spl_lvl[i]->color(spell_color[ms[k].spell_level]);
			ate_edit_spl_dsc[i]->color(spell_color[ms[k].spell_level]);
			ate_edit_spl_dsc[i]->value(ms[k].spell_name);
			sprintf(mybuf, "%d", ms[k].spell_count); ate_edit_spl_got[i]->value(mybuf);
			sprintf(mybuf, "%d", ms[k].spell_cast); ate_edit_spl_used[i]->value(mybuf);
		}
	}
}

/********************************************************************************/
void dontAcceptCopyright();
void doAcceptCopyright();

static void cb_copyrightNoButton(Fl_Button*, void*) {
  dontAcceptCopyright();
}
static void cb_copyrightButton(Fl_Button*, void*) {
  doAcceptCopyright();
}
Fl_Window* copyrightWindow;
/******************************************************************************/
void showCopyright() {
Fl_Button *copyrightButton=(Fl_Button *)0;
Fl_Button *copyrightNoButton=(Fl_Button *)0;
Fl_Output *copyrightMessage=(Fl_Output *)0;
if (debug == 1) printf("sC:\n");
	
	copyrightWindow = new Fl_Window(200, 100, "ATE: Copyright");
	{ Fl_Button* o = copyrightButton = new Fl_Button(25, 75, 50, 20, "I Accept");
	    o->labelsize(ATE_LABEL_SIZE);
	    o->callback((Fl_Callback*)cb_copyrightButton);
	}
	{ Fl_Button* o = copyrightNoButton = new Fl_Button(126, 75, 50, 20, "I Dont");
	    o->labelsize(ATE_LABEL_SIZE);
	    o->callback((Fl_Callback*)cb_copyrightNoButton);
	}
	{ Fl_Output* o = copyrightMessage = new Fl_Output(0, 0, 200, 70);
	    o->labelsize(ATE_LABEL_SIZE);
	    o->textsize(ATE_TEXT_SIZE);
		o->type(4);
		o->value("\t  AD&D 3Ed v1.4  11 Oct 2001\n\n\tCopyright Torquil Gault 2001+");
	}
	copyrightWindow->set_modal();
	copyrightWindow->end();
	copyrightWindow->show();
}
void dontAcceptCopyright() {
	exit(0);
}
void doAcceptCopyright() {
	copyrightWindow->hide();
}

// ********************************************************
void do_ate_logline_edit() {
	i = ate_session_text->value();
if (debug == 1) printf("llE: %d\n", i);
	if (strlen(ate_session_input->value()) == 0) {
		ate_session_input->value(ate_session_text->text(i));
	}
//	ate_session_ul->activate();
}

// ********************************************************
void do_ate_upd_log() {
	i = ate_session_text->value();
	ate_session_text->text(i, ate_session_input->value());
	ate_session_input->value("");
//	ate_session_ul->deactivate();
}

// ********************************************************
int do_ate_session_action() {
	switch (ate_session_action->value()) {
		case 0: do_ate_session_accept();
				break;
		case 1: do_ate_upd_log();
				break;
		case 2: do_ate_new_day();
				break;
		case 3: do_ate_new_session();
				break;
	}
}

// ********************************************************
int do_ate_spell_class(int cls) {
if (debug == 1) printf("dASC: %d\n", cls);
	clericSpells = NULL;
	wizardSpells = NULL;
	ate_x_spell_selector->clear();
	j = (int )ate_system_sp_lvl->value();
	spellType = cls;
	switch (spellType) {
	 case 0:
		ate_x_spell_domain->activate();
		for (i=1; i<j; i++) {
			sprintf(mybuf, "    Level: %d", i);
			clericSpells = clericspelldetails;
			ate_x_spell_selector->add(mybuf);
			while (clericSpells->name != NULL) {
				if (clericSpells->levels[0] == i) {
					ate_x_spell_selector->add(clericSpells->name);
				}
				clericSpells++;
			}
		}
		break;
	 case 1:
		ate_x_spell_domain->deactivate();
		for (i=1; i<j; i++) {
			sprintf(mybuf, "    Level: %d", i);
			wizardSpells = wizardspelldetails;
			ate_x_spell_selector->add(mybuf);
			while (wizardSpells->name != NULL) {
				if (wizardSpells->level == i) {
					ate_x_spell_selector->add(wizardSpells->name);
				}
				wizardSpells++;
			}
		}
		break;
	}
}

// ********************************************************
int do_ate_spell_domain(int dom) {
if (debug == 1) printf("dASD: %d\n", dom);
	clericSpells = NULL;
	wizardSpells = NULL;
	ate_x_spell_selector->clear();
	j = (int )ate_system_sp_lvl->value();
	switch (spellType) {
	 case 0:
		for (i=1; i<j; i++) {
			sprintf(mybuf, "    Level: %d", i);
			clericSpells = clericspelldetails;
			ate_x_spell_selector->add(mybuf);
			while (clericSpells->name != NULL) {
				if (clericSpells->levels[dom] == i) {
					ate_x_spell_selector->add(clericSpells->name);
				}
				clericSpells++;
			}
		}
		break;
	 case 1:
		break;
	}
}

// ********************************************************
int do_ate_spell_name() {
	strcpy(mybuf, ate_x_spell_name->value());
	i = strlen(mybuf);
if (debug == 1) printf("dASN: %s\n", mybuf);
	ate_x_spell_selector->clear();
	switch (spellType) {
	 case 0:
		if (mybuf[0] != '\0' && mybuf[0] != ' ') {
			clericSpells = clericspelldetails;
			while (clericSpells->name != NULL) {
				if (strncasecmp(mybuf, clericSpells->name, i) == 0) {
					ate_x_spell_selector->add(clericSpells->name);
				}
				clericSpells++;
			}
		}
		break;
	 case 1:
		if (mybuf[0] != '\0' && mybuf[0] != ' ') {
			wizardSpells = wizardspelldetails;
			while (wizardSpells->name != NULL) {
				if (strncasecmp(mybuf, wizardSpells->name, i) == 0) {
					ate_x_spell_selector->add(wizardSpells->name);
				}
				wizardSpells++;
			}
		}
		break;
	}
}

// ********************************************************
int do_ate_spell_select() {
	i = ate_x_spell_selector->value();
	if (i == 0) {
		return 0;
	}
	strcpy(mybuf, ate_x_spell_selector->text(i));
if (debug == 1) printf("dASS: %s (%d)\n", mybuf, i);
	ate_x_spell_desc->clear();
	switch (spellType) {
	 case 0:
		if (mybuf[0] != '\0' && mybuf[0] != ' ') {
			clericSpells = clericspelldetails;
			while (clericSpells->name != NULL) {
				if (strcmp(mybuf, clericSpells->name) == 0) {
					sprintf(mybuf, "Name: %s", clericSpells->name); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Comps: %s", clericSpells->components); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Cast: %s", clericSpells->casttime); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Range: %s", clericSpells->range); ate_x_spell_desc->add(mybuf);
					i = 0;
					if (clericSpells->sduration1 != 0 && clericSpells->sduration2 != 0) {
						sprintf(mybuf, "Duraction: %d+%d %s/lvl", clericSpells->sduration1, clericSpells->sduration2, clericSpells->duration); ate_x_spell_desc->add(mybuf);
					}
					else if (clericSpells->sduration2 != 0) {
						sprintf(mybuf, "Duraction: %d %s/lvl", clericSpells->sduration2, clericSpells->duration); ate_x_spell_desc->add(mybuf);
					} else if (clericSpells->sduration1 != 0) {
						sprintf(mybuf, "Duraction: %d %s", clericSpells->sduration1, clericSpells->duration); ate_x_spell_desc->add(mybuf);
					} else {
						sprintf(mybuf, "Duraction: %s", clericSpells->duration); ate_x_spell_desc->add(mybuf);
					}
					sprintf(mybuf, "Save: %s", clericSpells->save); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Resist: %s", clericSpells->resistance); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Page: %s", clericSpells->page); ate_x_spell_desc->add(mybuf);
					if (clericSpells->levels[0] != 0) {
						sprintf(mybuf, "Level: %d", clericSpells->levels[0]); ate_x_spell_desc->add(mybuf);
					} else {
						ate_x_spell_desc->add("Level: Domain Spell");
					}
					sprintf(mybuf, "Effect: %s", clericSpells->effects); ate_x_spell_desc->add(mybuf);
					break;
				}
				clericSpells++;
			}
		}
		break;
	 case 1:
		if (mybuf[0] != '\0' && mybuf[0] != ' ') {
			wizardSpells = wizardspelldetails;
			while (wizardSpells->name != NULL) {
				if (strcmp(mybuf, wizardSpells->name) == 0) {
					sprintf(mybuf, "Name: %s", wizardSpells->name); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "School: %s", wizardSpells->school); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Comps: %s", wizardSpells->components); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Cast: %s", wizardSpells->casttime); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Range: %s", wizardSpells->range); ate_x_spell_desc->add(mybuf);
					i = 0;
					if (wizardSpells->sduration1 != 0 && wizardSpells->sduration2 != 0) {
						sprintf(mybuf, "Duraction: %d+%d %s/lvl", wizardSpells->sduration1, wizardSpells->sduration2, wizardSpells->duration); ate_x_spell_desc->add(mybuf);
					}
					else if (wizardSpells->sduration2 != 0) {
						sprintf(mybuf, "Duraction: %d %s/lvl", wizardSpells->sduration2, wizardSpells->duration); ate_x_spell_desc->add(mybuf);
					} else if (wizardSpells->sduration1 != 0) {
						sprintf(mybuf, "Duraction: %d %s", wizardSpells->sduration1, wizardSpells->duration); ate_x_spell_desc->add(mybuf);
					} else {
						sprintf(mybuf, "Duraction: %s", wizardSpells->duration); ate_x_spell_desc->add(mybuf);
					}
					sprintf(mybuf, "Save: %s", wizardSpells->save); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Resist: %s", wizardSpells->resistance); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Page: %s", wizardSpells->page); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Level: %d", wizardSpells->level); ate_x_spell_desc->add(mybuf);
					sprintf(mybuf, "Effect: %s", wizardSpells->effects); ate_x_spell_desc->add(mybuf);
					break;
				}
				wizardSpells++;
			}
		}
		break;
	}
}

// ********************************************************
int do_ate_set_debug(int bug) {
if (debug == 1) printf("dASD: %d\n", bug);
	debug = bug;
}
