/*************************************************************************************/
#include <FL/Fl_Menu_Item.h>
#include <FL/Fl_Window.h>

/*************************************************************************************/
typedef unsigned char UCHAR;

// typedef struct skills {
// 	char *title;
// 	char *desc;
// } skills;

/*************************************************************************************/
Fl_Menu_Item SkillSelector[] = {
{"", 0, 0, (void *)0},
{"Alchemy", 0, 0, (void *)0},
{"Animal Empathy", 0, 0, (void *)0},
{"Appraise", 0, 0, (void *)0},
{"Balance", 0, 0, (void *)0},
{"Bluff", 0, 0, (void *)0},
{"Climb", 0, 0, (void *)0},
{"Concentration", 0, 0, (void *)0},
{"Craft", 0, 0, (void *)0},
{"Decipher Script", 0, 0, (void *)0},
{"Diplomacy", 0, 0, (void *)0},
{"Disable Device", 0, 0, (void *)0},
{"Disguise", 0, 0, (void *)0},
{"Escape Artist", 0, 0, (void *)0},
{"Forgery", 0, 0, (void *)0},
{"Gather Information", 0, 0, (void *)0},
{"Handle Animal", 0, 0, (void *)0},
{"Heal", 0, 0, (void *)0},
{"Hide", 0, 0, (void *)0},
{"Innuendo", 0, 0, (void *)0},
{"Intimidate", 0, 0, (void *)0},
{"Intuit Direction", 0, 0, (void *)0},
{"Jump", 0, 0, (void *)0},
{"Knowledge", 0, 0, (void *)0},
{"Knowledge (arcana)", 0, 0, (void *)0},
{"Knowledge (nature)", 0, 0, (void *)0},
{"Knowledge (religion)", 0, 0, (void *)0},
{"Listen", 0, 0, (void *)0},
{"Literacy", 0, 0, (void *)0},
{"Move Silently", 0, 0, (void *)0},
{"Open Lock", 0, 0, (void *)0},
{"Perform", 0, 0, (void *)0},
{"Pick Pocket", 0, 0, (void *)0},
{"Profession", 0, 0, (void *)0},
{"Read Lips", 0, 0, (void *)0},
{"Ride", 0, 0, (void *)0},
{"Scry", 0, 0, (void *)0},
{"Search", 0, 0, (void *)0},
{"Sense Motive", 0, 0, (void *)0},
{"Speak Language", 0, 0, (void *)0},
{"Spellcraft", 0, 0, (void *)0},
{"Spot", 0, 0, (void *)0},
{"Swim", 0, 0, (void *)0},
{"Tumble", 0, 0, (void *)0},
{"Use Magic Device", 0, 0, (void *)0},
{"Use Rope", 0, 0, (void *)0},
{"Wilderness Lore", 0, 0, (void *)0},
{0}
};

/*************************************************************************************/
typedef struct taken_skill {
	UCHAR skill_id;
	UCHAR skill_value;
	UCHAR skill_ranks;
	UCHAR skill_bonus;
} taken_skill;

typedef struct taken_spell {
	UCHAR spell_level;
	char  spell_name[30];
	UCHAR spell_count;
	UCHAR spell_cast;
} taken_spell;

typedef struct taken_weapon {
	char  weap_name[20];
	UCHAR weap_bonus;
	char  weap_damage[10];
	char  weap_critical[10];
	UCHAR weap_range;
} taken_weapon;

/*************************************************************************************/
typedef struct mysystem {
	char fn_players[20];
	char fn_monsters[20];
	char fn_extras[20];
} mysystem;

typedef struct character {
	char	name[20];
	UCHAR	level;
	int	hits_max;
	int	hits_cur;
	int	ac;
	int	saves[4];
	taken_skill my_skills[20];
	taken_spell my_spells[60];
	taken_weapon my_weapons[4];
	char	notes[110];
	char	spells[9][5];
	int	xp;
	int	pp;
	int	gp;
} character;

character ATEplayers[20];
mysystem ATEsystem;

Fl_Window *ATEWindow;
